#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>
#include <errno.h>
//#include <termios.h>
#include <pthread.h>
//#include <sys/types.h>
//#include <sys/stat.h>
#include <fcntl.h>
#include "../head/func_extern.h"
#include "../head/mg3.h"
#include "../head/control.h"
//#include "../main/pwm_enc.h"
#include "../head/motor.h"
#include "../mirs_two.h"

#define RIGHT 0
#define LEFT 1

//プロトタイプ宣言
void key_straight(int);

//外部変数の宣言
int key_sensor_interrupt=0;
int key_flag=0;
extern key_sensor_thread(void);
extern key_rotate(void);

void keyact(void){
//int main(void){
//変数宣言
	int ret1;
	int c_left,c_right;
	int dis;
	int x_l,x_r;
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
//スレッド設定
	pthread_t sensor_t;
	pthread_attr_t attr_sensor_t;
	pthread_attr_init (&attr_sensor_t);
	pthread_attr_setschedpolicy(&attr_sensor_t, SCHED_RR);		//スレッドのスケジューリング方針をラウンドロビンで
//モータデバイスオープン
	printf("opening device...\n");
	fd1 = open(M_PORT_L, O_RDWR);
	if(fd1 < 0){
		if(errno == 3)
			printf("no such file\n");
		else if(errno == 13)
			printf("permission\n");
		else
			printf("other\n");
		fprintf(stderr, "fd1 open error\n");
		exit(-1);
	}
	fd2 = open(M_PORT_R, O_RDWR);
	if(fd2 < 0){
		if(errno == 3)
			printf("no such file\n");
		else if(errno == 13)
			printf("permission\n");
		else
			printf("other\n");
		fprintf(stderr, "fd2 open error\n");
		close(fd1);
		exit(-1);
	}
	printf("end\n");
	motor_send_start_packet(fd1);
	motor_send_start_packet(fd2);
//スレッド作成
       	ret1 = pthread_create( &sensor_t, &attr_sensor_t,(void*)key_sensor_thread,NULL);
	if(ret1 != 0){
		printf ("sensor pthread create error!!\n");
		exit(1);
	}
//スピード設定
	dis = -5000;					//要はずっと後退
	v_l = KEY_SPEED;
	v_r = KEY_SPEED;
	v_lm = v_l;					//初期速度を保存
	v_rm = v_r;
	motor_send_clear_packet(fd1);			//エンコーダ値をクリア
	motor_send_clear_packet(fd2);
	usleep(130*1000);
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);
	usleep(130*1000);
	c_left=0;
	c_right=0;

//スタート
	printf("************key program************\n");
	while(1){
		//開始時は鍵の方向を向いている
		//バックタッチセンサが反応するまで後退する
		//途中で他のタッチセンサは反応しないだろう
		while(key_flag == 0){
			if(x_l - x_r > 5){			//左タイヤの移動距離が多い場合
				v_lm = v_l+5;				//左+5 : 右-5
				v_rm = v_r-5;
			}
			else if(x_r - x_l > 5){		//右タイヤの移動距離が多い場合
				v_lm = v_l-5;				//左-5 : 右+5
				v_rm = v_r+5;
			}
			else{					//左右にズレがない場合
				v_lm = v_l;				//初期速度
				v_rm = v_r;
			}
			motor_send_control_packet(fd1,v_lm,Kp,Ki);
			motor_send_control_packet(fd2,v_rm,Kp,Ki);
			usleep(130*1000);
			motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
			motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
			c_left=m_info_l.puls;
			c_right=m_info_r.puls;
			x_l=(int)(c_left*t_par);
			x_r=(int)(c_right*t_par);
			printf("vl = %d, vr = %d, xl = %d, xr = %d\n\n", v_lm, v_rm, x_l, x_r);
		}
	//センサ処理
		if(key_sensor_interrupt == F_TS_FLAG){		//後ろのタッチセンサが反応
			motor_send_control_packet(fd1,0,Kp,Ki);
			motor_send_control_packet(fd2,0,Kp,Ki);
			usleep(1000*1000);
			key_rotate();				//180°回転
			usleep(1000*1000);
			key_straight(1000);			//前に1m前進して終了
			key_flag = 0;
			break;
		}
	}
	motor_send_control_packet(fd1,0,Kp,Ki);
	motor_send_control_packet(fd2,0,Kp,Ki);
	motor_send_stop_packet(fd1);
	motor_send_stop_packet(fd2);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	close(fd1);
	close(fd2);
	close(fd4);
	pthread_cancel(sensor_t);
	return ;
}
